# Пользовательские сессии

### К чему эта задача

Попробуйте на задаче, приближенной к реальности, ещё раз лично оценить - STL это удобно, или лучше всё писать самостоятельно с нуля.


### Легенда

У нас есть нагруженная многопользовательская система. Хочется следить за тем, сколько пользователей активно в данный момент. *(Кто именно активен - в рамках данной задачи следить не требуется, но в реальной жизни это требование возникнет примерно сразу после того, как будет выполнен подсчёт количества.)*


### Постановка задачи

Напишите класс, мониторящий вход и выход пользователей, вот с таким прототипом:

```cpp
class SessionManager
{
public:
    // Вход пользователя.
    // Один пользователь может войти несколько раз подряд, 
    // считать его при этом нужно один раз.
    void login(string username);

    // Выход пользователя.
    // Пользователь может выйти несколько раз подряд, 
    // падать при этом не нужно.
    void logout(string username);

    // Сколько сейчас пользователей залогинено.
    int getNumberOfActiveUsers();
};
```

При каждом входе пользователя наш класс уведомляют об этом, вызвав метод login. В этот момент нужно учесть, что данный пользователь стал активен. При выходе пользователя вызывается метод logout, нужно так или иначе вычеркнуть пользователя из активных.


Пример ожидаемого сценария работы всей конструкции:
```cpp
    SessionManager m;
    m.login("alice");
    cout << m.getNumberOfActiveUsers() << endl;
    m.login("bob");
    cout << m.getNumberOfActiveUsers() << endl;
    m.login("alice");
    cout << m.getNumberOfActiveUsers() << endl;
    m.logout("whoever");
    cout << m.getNumberOfActiveUsers() << endl;
    m.logout("alice");
    cout << m.getNumberOfActiveUsers() << endl;
    m.logout("bob");
    cout << m.getNumberOfActiveUsers() << endl;
```

Будьте внимательны к ситуациям вида "повторный логин того же пользователя" или "попытка выхода того, кто никогда не входил"! В данном примере должна получиться вот такая статистика:
```
1
2
2
2
1
0
```

### Файлы к задаче

В этой папке лежит sessions\_task.cpp. Это заготовка, в которую нужно вписать свой класс.
