Это предельно компактный проект, на котором можно проверить, что у вас в норме окружение CMake. Проект состоит из:
- файл исходного текста - 1 штука, уровня hello world
- сценарий CMake - 1 строчка

# CMake на Linux (с использованием gcc/g++)

Считаем, что gcc/g++ у вас на данный момент уже есть.

Ставим cmake из репозиториев. Примерно так:
- apt-get install cmake (для Ubuntu / Debian)
- yum install cmake (для Fedora / CentOS / RHEL / Scientific Linux / etc)
Если у вас более экзотичный дистрибутив, то, наверное, вы сами знаете, как поставить cmake.

Далее в консоли переходим в папку, в которую вы загрузили test.c и CMakeLists.txt данного проекта. Выполняем:

```
mkdir build  // Создали папку, чтобы не мусорить временными файлами в основном дереве исходников.
cd build     // Перешли в эту папку.
cmake ..     // Вызвали cmake, указав путь к исходникам как .. (логически "на одну папку выше от текущей").
             // На этом моменте должен быть сгенерирован Makefile.
make         // Собственно сборка по Makefile-у.
             // На этом моменте должен появиться бинарник hello
./hello      // Торжественно запускаем результат. Ура - окружение сборки в норме!
```

# CMake на Windows (с использованием MinGW)

1. При установке MinGW нужно убедиться, что выбраны компоненты mingw32-base и mingw32-gcc-g++.

2. Проверяем, что MinGW прописан в PATH, и в итоге команда mingw32-c++ нормально запускается в произвольной папке. Достаточно открыть консоль и вызвать в ней mingw32-c++. Оно скажет fatal error: no input files - это нормально. Это означает, что сам компилятор найден, запущен, но просто не получил файл на вход.

Возможные проблемы на этом этапе:
- MinGW есть, но в PATH не прописан. Пропишите примерно вот так - http://www.nicothin.pro/page/windows-path Для проверки откройте консоль, запустите команду path. Она покажет список путей, разделённых символом ; - проверьте, что в них есть путь ВАШ\_КОРЕНЬ\_УСТАНОВКИ\MinGW\bin
- MinGW точно есть в PATH, путь к нему показывает команда path, но mingw32-c++ категорически не хочет запускаться. В силу пока неустановленных причин Windows иногда отказывается запускать что-либо с диска, отличного от системного. Попробуйте поставить MinGW на диск C: (ну или на тот, который системный в вашем случае).

3. Ставим CMake. Проверяем, что он есть в PATH и cmake нормально запускается в произвольной папке. Всё полностью аналогично MinGW.

4. Теперь наконец в консоли переходим в папку, в которую вы загрузили test.c и CMakeLists.txt данного проекта. Выполняем:
```
mkdir build     // Создали папку, чтобы не мусорить временными файлами в основном дереве исходников.
cd build        // Перешли в эту папку.
cmake .. -G "MinGW Makefiles"   // Вызвали cmake, указав путь к исходникам как .. (логически "на одну папку выше от текущей").
                                // Опция -G "MinGW Makefiles" отвечает за то, что для реальной сборки будет использоваться MinGW.
                                // На этом моменте должен быть сгенерирован Makefile.
mingw32-make    // Собственно сборка по Makefile-у.
                // На этом моменте должен появиться бинарник hello.exe
hello.exe       // Торжественно запускаем результат. Ура - окружение сборки в норме!

