#include <iostream>
#include <vector>
#include <cstdlib>

using namespace std;

int main()
{
    // Создаём вектор
    vector<int> v;
    // Заполняем 
    for (int  i = 0; i < 10; i++)
        v.push_back(i);

    // Создаем ссылку, которая вроде как безопасная
    int& the_fifth_element = v[5];

    // Докинем еще чисел
    for (int  i = 0; i < 10; i++)
        v.push_back(i);

    // Выводим на экран значение по ссылке.
    // На таком маленьком примере надо смотреть под valgrind.
    v[5] = 10;
    cout << the_fifth_element << endl;
    // А где? А нету. Вектор переехал из-за ресайза.
    // Ссылка не виновата - она не изменилась и указывает туда же.

    // В реальной жизни проблема будет выглядеть так.
    // Ссылки и указатели на элементы вектора, которые вы сохранили, 
    // внезапно начнут выдавать странные произвольные значения. 
    // Это "плавающая ошибка", которую тяжело поймать.
    // Это очень плохо. Избегайте такого заранее.  
       
    return 0;
}
