#include <iostream>
#include <vector>

using namespace std;

// Здесь показаны *не* все ограничения auto.
// Здесь примеры только самых массовых ситуаций.
// Вообще автоматическое выведение типа - сложная штука.

class A
{
protected:
    // Это приведёт к ошибке компиляции.
    // В общем случае поле класса auto быть не может.
    //auto x;
};

int main()
{
    // Так можно
    auto i = 42;
    cout << i << endl;

    // И так, конечно, тоже
    auto s = "foobar";
    cout << s << endl;

    // Строки ниже приведут к ошибке компиляции.
    // auto - это не 'отсутствие типа, можно писать что угодно'.
    // auto - это 'тип будет проставлен компилятором при инициализации'.
    // auto a = 1;
    // a = "foo";

    // И это тоже приведёт к ошибке компиляции.
    // См. выше - для auto обязательна инициализация сразу.
    // auto c;
    // c = 1;
  
    // Обычно auto используют, чтобы сократить запись длинных типов,
    // когда они не важны для понимания происходящего в текущей строчке.
    vector<int> v {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
    for (auto it = v.begin(); it != v.end(); ++it)
        cout << *it << " ";
    cout << endl;

    return 0;
}
